_LUI.config.colors = {
	RED			= { r = 1    , g = 0    , b = 0    },
	GREEN		= { r = 0    , g = 1    , b = 0    },
	BLUE		= { r = 0    , g = 0    , b = 1    },
	YELLOW		= { r = 1    , g = 1    , b = 0    },
	WHITE		= { r = 1    , g = 1    , b = 1    },
	BLACK		= { r = 0    , g = 0    , b = 0    },
	EXP			= { r = 0.07 , g = 0.45 , b = 0.80 },
	VP			= { r = 0.54 , g = 0.51 , b = 0.37 },
	GROUPLEADER	= { r = 1    , g = 0    , b = 0    },
	GROUPMEMBER	= { r = 0    , g = 1    , b = 0    },
	DAMAGE		= { r = 0.80 , g = 0.07 , b = 0.10 },
	DAMAGECRIT	= { r = 0.80 , g = 0.64 , b = 0.10 },
	HEAL		= { r = 0.07 , g = 0.80 , b = 0.45 },
	HEALCRIT	= { r = 0.03 , g = 0.85 , b = 0.27 },
	MAGICKA		= { r = 0.09 , g = 0.33 , b = 0.60 },
	HEALTH		= { r = 0.80 , g = 0.07 , b = 0.10 },
	STAMINA		= { r = 0.23 , g = 0.54 , b = 0.53 },
	ULTIMATE	= { r = 0.90 , g = 0.90 , b = 0.90 },
	SHIELDED	= { r = 0.80 , g = 0.10 , b = 0.50 },
}

_LUI.config.equipmentSlots = {
	[ 'HELM' ]			= EQUIP_SLOT_HEAD,
	[ 'CHEST' ]			= EQUIP_SLOT_CHEST,
	[ 'SHOULDERS' ]		= EQUIP_SLOT_SHOULDERS,
	[ 'FEET' ]			= EQUIP_SLOT_FEET,
	[ 'HANDS' ]			= EQUIP_SLOT_HAND,
	[ 'LEGS' ]			= EQUIP_SLOT_LEGS,
	[ 'WAIST' ]			= EQUIP_SLOT_WAIST,
	[ 'RING1' ]			= EQUIP_SLOT_RING1,
	[ 'RING2' ]			= EQUIP_SLOT_RING2,
	[ 'NECK' ]			= EQUIP_SLOT_NECK,
	[ 'COST' ]			= EQUIP_SLOT_COSTUME,
	[ 'MAIN_WEAP' ]		= EQUIP_SLOT_MAIN_HAND,
	[ 'OFF_HAND' ]		= EQUIP_SLOT_OFF_HAND,
	[ 'BACKUP_MAIN' ]	= EQUIP_SLOT_BACKUP_MAIN,
	[ 'BACKUP_OFF' ]	= EQUIP_SLOT_BACKUP_OFF
}

_LUI.config.combatTargets = {}
_LUI.config.combatTargets[ 'Target' ] = {
	labelsMax        = 20,
	labelsCount      = 0,
	queue            = false,
	grid             = true,
	showIcon         = true,
	animateAlpha     = true,
	animateScale     = true,
	animateY         = 1,
	animateX         = 0,
	animateSpeed     = 2,
	animateTime      = 2000,
	fixedTime        = 250,
	align            = CENTER,
	alignIcon        = TOPRIGHT,
	alignIconTarget  = TOPLEFT,
	alignIconOffsetX = -4,
	alignIconOffsetY = 0,
}
_LUI.config.combatTargets[ 'TargetInfo' ] = _LUI.config.combatTargets[ 'Target' ]
_LUI.config.combatTargets[ 'PlayerDown' ] = {
	labelsMax        = 20,
	labelsCount      = 0,
	queue            = true,
	grid             = false,
	showIcon         = true,
	animateAlpha     = true,
	animateScale     = false,
	animateY         = 2,
	animateX         = 0,
	animateSpeed     = 3,
	animateTime      = 4000,
	fixedTime        = 0,
	align            = RIGHT,
	alignIcon        = TOPLEFT,
	alignIconTarget  = TOPRIGHT,
	alignIconOffsetX = 10,
	alignIconOffsetY = 0,
}
_LUI.config.combatTargets[ 'PlayerUp' ] = {
	labelsMax        = 20,
	labelsCount      = 0,
	queue            = true,
	grid             = false,
	showIcon         = true,
	animateAlpha     = true,
	animateScale     = false,
	animateY         = 1,
	animateX         = 0,
	animateSpeed     = 3,
	animateTime      = 4000,
	fixedTime        = 0,
	align            = RIGHT,
	alignIcon        = TOPLEFT,
	alignIconTarget  = TOPRIGHT,
	alignIconOffsetX = 10,
	alignIconOffsetY = 0,
}
_LUI.config.combatTargets[ 'OtherDown' ] = {
	labelsMax        = 20,
	labelsCount      = 0,
	queue            = true,
	grid             = false,
	showIcon         = true,
	animateAlpha     = true,
	animateScale     = false,
	animateY         = 2,
	animateX         = 0,
	animateSpeed     = 3,
	animateTime      = 4000,
	fixedTime        = 0,
	align            = LEFT,
	alignIcon        = TOPRIGHT,
	alignIconTarget  = TOPLEFT,
	alignIconOffsetX = -10,
	alignIconOffsetY = 0,
}
_LUI.config.combatTargets[ 'OtherUp' ] = {
	labelsMax        = 20,
	labelsCount      = 0,
	queue            = true,
	grid             = false,
	showIcon         = true,
	animateAlpha     = true,
	animateScale     = false,
	animateY         = 1,
	animateX         = 0,
	animateSpeed     = 3,
	animateTime      = 4000,
	fixedTime        = 0,
	align            = LEFT,
	alignIcon        = TOPRIGHT,
	alignIconTarget  = TOPLEFT,
	alignIconOffsetX = -10,
	alignIconOffsetY = 0,
}
_LUI.config.combatTargets[ 'Magicka' ] = {
	labelsMax        = 20,
	labelsCount      = 0,
	queue            = true,
	grid             = false,
	showIcon         = true,
	animateAlpha     = true,
	animateScale     = false,
	animateY         = 1,
	animateX         = 0,
	animateSpeed     = 3,
	animateTime      = 2000,
	fixedTime        = 0,
	align            = CENTER,
	alignIcon        = TOPRIGHT,
	alignIconTarget  = TOPRIGHT,
	alignIconOffsetX = 0,
	alignIconOffsetY = 0,
}
_LUI.config.combatTargets[ 'Health' ]       = _LUI.config.combatTargets.Magicka
_LUI.config.combatTargets[ 'Stamina' ]      = _LUI.config.combatTargets.Magicka
_LUI.config.combatTargets[ 'MountStamina' ] = _LUI.config.combatTargets.Magicka
_LUI.config.combatTargets[ 'Ultimate' ]     = _LUI.config.combatTargets.Magicka

_LUI.config.combatEvents = {
	[99999999997] = { -- Exp gain
		[COMBAT_UNIT_TYPE_PLAYER] = {
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'TargetInfo',
				color  = _LUI.config.colors.EXP,
				font   = 'LUIFontAnnounceLarge',
				strfmt = '+%1$d EXP',
			},
		},
	},
	[99999999998] = { -- Vp gain
		[COMBAT_UNIT_TYPE_PLAYER] = {
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'TargetInfo',
				color  = _LUI.config.colors.VP,
				font   = 'LUIFontAnnounceLarge',
				strfmt = '+%1$d VP',
			},
		},
	},
	[ACTION_RESULT_DAMAGE] = {
		[COMBAT_UNIT_TYPE_NONE] = {
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerDown',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontGame',
				strfmt = '%1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerDown',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontGame',
				strfmt = 'PET %1$d',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontAnnounceMedium',
				strfmt = '%1$d',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontAnnounceMedium',
				strfmt = '%1$d',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER_PET] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontAnnounceMedium',
				strfmt = '%1$d PET',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontAnnounceMedium',
				strfmt = '%1$d PET',
			},
		},
	},
	[ACTION_RESULT_BLOCKED_DAMAGE] =
	{
		[COMBAT_UNIT_TYPE_NONE] = {
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerDown',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontGame',
				strfmt = 'BLOCKED %1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerDown',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontGame',
				strfmt = 'BLOCKED %1$d',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontAnnounceMedium',
				strfmt = '%1$d BLOCKED',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontAnnounceMedium',
				strfmt = '%1$d BLOCKED',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER_PET] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontAnnounceMedium',
				strfmt = '%1$d PET BLOCKED',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontAnnounceMedium',
				strfmt = '%1$d PET BLOCKED',
			},
		},
	},
	[ACTION_RESULT_FALL_DAMAGE] =
	{
		[COMBAT_UNIT_TYPE_NONE] = {
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerDown',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontGame',
				strfmt = 'FALL DAMAGE %1$d',
			},
		},
	},
	[ACTION_RESULT_CRITICAL_DAMAGE] =
	{
		[COMBAT_UNIT_TYPE_NONE] = {
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerDown',
				color  = _LUI.config.colors.DAMAGECRIT,
				font   = 'LUIFontGame',
				strfmt = 'CRITICAL %1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerDown',
				color  = _LUI.config.colors.DAMAGECRIT,
				font   = 'LUIFontGame',
				strfmt = 'CRITICAL %1$d',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGECRIT,
				font   = 'LUIFontAnnounceLarge',
				strfmt = '%1$d CRITICAL',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGECRIT,
				font   = 'LUIFontAnnounceLarge',
				strfmt = '%1$d CRITICAL',
			},
		},[COMBAT_UNIT_TYPE_PLAYER_PET] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGECRIT,
				font   = 'LUIFontAnnounceLarge',
				strfmt = '%1$d PET CRITICAL',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGECRIT,
				font   = 'LUIFontAnnounceLarge',
				strfmt = '%1$d PET CRITICAL',
			},
		},
	},
	[ACTION_RESULT_DOT_TICK] =
	{
		[COMBAT_UNIT_TYPE_NONE] = {
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerDown',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontGame',
				strfmt = '-%1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerDown',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontGame',
				strfmt = '-%1$d',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontGame',
				strfmt = '-%1$d',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontGame',
				strfmt = '-%1$d',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER_PET] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontGame',
				strfmt = '-%1$d PET',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGE,
				font   = 'LUIFontGame',
				strfmt = '-%1$d PET',
			},
		},
	},
	[ACTION_RESULT_DOT_TICK_CRITICAL] =
	{
		[COMBAT_UNIT_TYPE_NONE] = {
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerDown',
				color  = _LUI.config.colors.DAMAGECRIT,
				font   = 'LUIFontGame',
				strfmt = '-%1$d CRITICAL',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerDown',
				color  = _LUI.config.colors.DAMAGECRIT,
				font   = 'LUIFontGame',
				strfmt = 'CRITICAL -%1$d',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGECRIT,
				font   = 'LUIFontGame',
				strfmt = '-%1$d CRITICAL',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGECRIT,
				font   = 'LUIFontGame',
				strfmt = '-%1$d CRITICAL',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER_PET] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGECRIT,
				font   = 'LUIFontGame',
				strfmt = 'PET CRITICAL -%1$d',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'Target',
				color  = _LUI.config.colors.DAMAGECRIT,
				font   = 'LUIFontGame',
				strfmt = 'PET CRITICAL -%1$d',
			},
		},
	},
	[ACTION_RESULT_HEAL] =
	{
		[COMBAT_UNIT_TYPE_NONE] = {
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = '%1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = 'PET %1$d',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontAnnounceMedium',
				strfmt = '%1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = '%1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = 'PET %1$d',
			},
			[COMBAT_UNIT_TYPE_GROUP] = {
				target = 'Target',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontAnnounceMedium',
				strfmt = '%1$d',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'OtherUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = '%1$d (%3$s)',
			},
		},
	},
	[ACTION_RESULT_CRITICAL_HEAL] =
	{
		[COMBAT_UNIT_TYPE_NONE] = {
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = 'CRITICAL %1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = 'CRITICAL PET %1$d',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontAnnounceMedium',
				strfmt = '%1$d CRITICAL',
			},
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = 'CRITICAL %1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = 'CRITICAL PET %1$d',
			},
			[COMBAT_UNIT_TYPE_GROUP] = {
				target = 'Target',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = '%1$d CRITICAL',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'OtherUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = '%1$d CRITICAL (%3$s)',
			},
		},
	},
	[ACTION_RESULT_HOT_TICK] =
	{
		[COMBAT_UNIT_TYPE_NONE] = {
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = '+%1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = 'PET +%1$d',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = '+%1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = '+%1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = 'PET +%1$d',
			},
			[COMBAT_UNIT_TYPE_GROUP] = {
				target = 'Target',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = '+%1$d',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'OtherUp',
				color  = _LUI.config.colors.HEAL,
				font   = 'LUIFontGame',
				strfmt = '+%1$d (%3$s)',
			},
		},
	},
	[ACTION_RESULT_HOT_TICK_CRITICAL] =
	{
		[COMBAT_UNIT_TYPE_NONE] = {
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEALCRIT,
				font   = 'LUIFontGame',
				strfmt = 'CRITICAL +%1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEALCRIT,
				font   = 'LUIFontGame',
				strfmt = '<CRITICAL PET +%1$d',
			},
		},
		[COMBAT_UNIT_TYPE_PLAYER] = {
			[COMBAT_UNIT_TYPE_NONE] = {
				target = 'Target',
				color  = _LUI.config.colors.HEALCRIT,
				font   = 'LUIFontGame',
				strfmt = '+%1$d CRITICAL',
			},
			[COMBAT_UNIT_TYPE_PLAYER] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEALCRIT,
				font   = 'LUIFontGame',
				strfmt = 'CRITICAL +%1$d',
			},
			[COMBAT_UNIT_TYPE_PLAYER_PET] = {
				target = 'PlayerUp',
				color  = _LUI.config.colors.HEALCRIT,
				font   = 'LUIFontGame',
				strfmt = 'CRITICAL PET +%1$d',
			},
			[COMBAT_UNIT_TYPE_GROUP] = {
				target = 'Target',
				color  = _LUI.config.colors.HEALCRIT,
				font   = 'LUIFontGame',
				strfmt = '+%1$d CRITICAL',
			},
			[COMBAT_UNIT_TYPE_OTHER] = {
				target = 'OtherUp',
				color  = _LUI.config.colors.HEALCRIT,
				font   = 'LUIFontGame',
				strfmt = '+%1$d CRITICAL (%3$s)',
			},
		},
	},
	-- [ACTION_RESULT_POWER_DRAIN] =
	-- {
		-- [COMBAT_UNIT_TYPE_PLAYER] = {
			-- [COMBAT_UNIT_TYPE_PLAYER] = {
				-- powers = true,
				-- target = {
					-- [POWERTYPE_MAGICKA]       = 'Magicka',
					-- [POWERTYPE_HEALTH]        = 'Health',
					-- [POWERTYPE_STAMINA]       = 'Stamina',
					-- [POWERTYPE_MOUNT_STAMINA] = 'MountStamina',
					-- [POWERTYPE_ULTIMATE]      = 'Ultimate',
				-- },
				-- color  = {
					-- [POWERTYPE_MAGICKA]       = _LUI.config.colors.MAGICKA,
					-- [POWERTYPE_HEALTH]        = _LUI.config.colors.HEALTH,
					-- [POWERTYPE_STAMINA]       = _LUI.config.colors.STAMINA,
					-- [POWERTYPE_MOUNT_STAMINA] = _LUI.config.colors.STAMINA,
					-- [POWERTYPE_ULTIMATE]      = _LUI.config.colors.ULTIMATE,
				-- },
				-- font   = {
					-- [POWERTYPE_MAGICKA]       = 'LUIFontGame',
					-- [POWERTYPE_HEALTH]        = 'LUIFontGame',
					-- [POWERTYPE_STAMINA]       = 'LUIFontGame',
					-- [POWERTYPE_MOUNT_STAMINA] = 'LUIFontGame',
					-- [POWERTYPE_ULTIMATE]      = 'LUIFontGame',
				-- },
				-- strfmt = {
					-- [POWERTYPE_MAGICKA]       = '-%1$d',
					-- [POWERTYPE_HEALTH]        = '-%1$d',
					-- [POWERTYPE_STAMINA]       = '-%1$d',
					-- [POWERTYPE_MOUNT_STAMINA] = '-%1$d',
					-- [POWERTYPE_ULTIMATE]      = '-%1$d',
				-- },
			-- },
		-- },
	-- },
}