------------------
-- UnitInfo class
__UnitInfo               = ZO_Object:Subclass()
__UnitInfo.savedVars     = nil

-- -- group
__UnitInfo.group         = {}
__UnitInfo.player        = {}
__UnitInfo.target        = {}

-- -- other
__UnitInfo.classABR = {
	[ 0 ] = '?',
	[ 1 ] = 'DK',
	[ 2 ] = 'S',
	[ 3 ] = 'NB',
	[ 6 ] = 'T',
}
__UnitInfo.distanceMods = {
	[ 0 ]   = { -- Default
		[MAPTYPE_SUBZONE] = 0.01836583,
		[MAPTYPE_ZONE]    = 0.00319136,
	},
	[ 178 ] = { -- Auridon
		[MAPTYPE_SUBZONE] = 0.00152317,
		[MAPTYPE_ZONE]    = 0.00027557,
	},
	[ 18 ]  = { -- Grünschatten
		[MAPTYPE_SUBZONE] = 0.00227458,
		[MAPTYPE_ZONE]    = 0.00033131,
	},
	[ 180 ] = { -- Grahtwald
		[MAPTYPE_SUBZONE] = 0.00139860,
		[MAPTYPE_ZONE]    = 0.00028644,
	},
	[ 11 ]  = { -- Malabal Tor
		[MAPTYPE_SUBZONE] = 0.00147150,
		[MAPTYPE_ZONE]    = 0.00030799,
	},
	[ 179 ] = { -- Schnittermark
		[MAPTYPE_SUBZONE] = 0.00151211,
		[MAPTYPE_ZONE]    = 0.00029846,
	},
	[ 154 ] = { -- Kalthafen
		[MAPTYPE_SUBZONE] = 0.00210541,
		[MAPTYPE_ZONE]    = 0.00023412,
	},
	[ 9 ]   = { -- Steinfälle
		[MAPTYPE_SUBZONE] = 0.00151535,
		[MAPTYPE_ZONE]    = 0.00031787,
	},
	[ 10 ]  = { -- Deshaan
		[MAPTYPE_SUBZONE] = 0.00139020,
		[MAPTYPE_ZONE]    = 0.00031033,
	},
	[ 19 ]  = { -- Schattenfenn
		[MAPTYPE_SUBZONE] = 0.00163157,
		[MAPTYPE_ZONE]    = 0.00033236,
	},
	[ 15 ]  = { -- Ostmarsch
		[MAPTYPE_SUBZONE] = 0.00177463,
		[MAPTYPE_ZONE]    = 0.00024825,
	},
	[ 16 ]  = { -- Rift
		[MAPTYPE_SUBZONE] = 0.00176873,
		[MAPTYPE_ZONE]    = 0.00024866,
	},
	[ 2 ]  = { -- Glenumbra
		[MAPTYPE_SUBZONE] = 0.00125126,
		[MAPTYPE_ZONE]    = 0.00026436,
	},
	[ 4 ]  = { -- Sturmhafen
		[MAPTYPE_SUBZONE] = 0.00240331,
		[MAPTYPE_ZONE]    = 0.00031207,
	},
	[ 14 ]  = { -- Bankorai
		[MAPTYPE_SUBZONE] = 0.00140984,
		[MAPTYPE_ZONE]    = 0.00029800,
	},
	[ 5 ]  = { -- Kluftspitze
		[MAPTYPE_SUBZONE] = 0.00207526,
		[MAPTYPE_ZONE]    = 0.00032626,
	},
}

function __UnitInfo:New( ... )
	local result = ZO_Object.New( self )
	result:Initialize( ... )
	return result
end

function __UnitInfo:Initialize( control )
	-- set controls
	self.control = control

	-- load settings
	local defaults = {
		groupFrame         = false,
		groupOffsetX       = 150,
		groupOffsetY       = 150,
		targetFrame        = true,
		targetOffsetX      = 1000,
		targetOffsetY      = 900,
		playerFrame        = true,
		playerFrameToggle  = false,
		playerOffsetX      = 720,
		playerOffsetY      = 900,
		buffsFrame         = true,
		buffsTargetOffsetX = 0,
		buffsTargetOffsetY = -350,
		buffsPlayerOffsetX = 0,
		buffsPlayerOffsetY = 350,
	}
	self.savedVars = ZO_SavedVars:NewAccountWide( string.format( '%s_%s', _LUI.addOnName, 'SavedVariables' ), _LUI.savedVarsID, 'UnitInfo', defaults )

	UnitInfo_Group:SetHidden( not self.savedVars.groupFrame )
	UnitInfo_Target:SetHidden( not self.savedVars.targetFrame )
	UnitInfo_Player:SetHidden( not self.savedVars.playerFrame )
	UnitInfo_Buffs:SetHidden( not self.savedVars.buffsFrame )

	ZO_UnitFramesGroups:SetHidden( self.savedVars.groupFrame )
	ZO_PlayerAttributeMagicka:SetHidden( self.savedVars.playerFrame )
	ZO_PlayerAttributeHealth:SetHidden( self.savedVars.playerFrame )
	ZO_PlayerAttributeStamina:SetHidden( self.savedVars.playerFrame )
	ZO_PlayerAttributeMountStamina:SetHidden( self.savedVars.playerFrame )
	ZO_TargetUnitFramereticleover:SetHidden( self.savedVars.targetFrame )

	UnitInfo_Group:ClearAnchors()
	UnitInfo_Group:SetAnchor( TOPLEFT, GuiRoot, TOPLEFT, self.savedVars.groupOffsetX, self.savedVars.groupOffsetY )
	UnitInfo_Group:SetHandler( 'OnMoveStop', function()
		self.savedVars.groupOffsetX = UnitInfo_Group:GetLeft()
		self.savedVars.groupOffsetY = UnitInfo_Group:GetTop()
	end )
	UnitInfo_Target:ClearAnchors()
	UnitInfo_Target:SetAnchor( TOPLEFT, GuiRoot, TOPLEFT, self.savedVars.targetOffsetX, self.savedVars.targetOffsetY )
	UnitInfo_Target:SetHandler( 'OnMoveStop', function()
		self.savedVars.targetOffsetX = UnitInfo_Target:GetLeft()
		self.savedVars.targetOffsetY = UnitInfo_Target:GetTop()
	end )
	UnitInfo_Player:ClearAnchors()
	UnitInfo_Player:SetAnchor( TOPLEFT, GuiRoot, TOPLEFT, self.savedVars.playerOffsetX, self.savedVars.playerOffsetY )
	UnitInfo_Player:SetHandler( 'OnMoveStop', function()
		self.savedVars.playerOffsetX = UnitInfo_Player:GetLeft()
		self.savedVars.playerOffsetY = UnitInfo_Player:GetTop()
	end )
	UnitInfo_Buffs_Player:ClearAnchors()
	UnitInfo_Buffs_Player:SetAnchor( CENTER, GuiRoot, CENTER, self.savedVars.buffsPlayerOffsetX, self.savedVars.buffsPlayerOffsetY )
	UnitInfo_Buffs_Player:SetHandler( 'OnMoveStop', function()
		self.savedVars.buffsPlayerOffsetX = UnitInfo_Buffs_Player:GetLeft() + ( UnitInfo_Buffs_Player:GetWidth() / 2 ) - ( GuiRoot:GetWidth() / 2 )
		self.savedVars.buffsPlayerOffsetY = UnitInfo_Buffs_Player:GetTop() + ( UnitInfo_Buffs_Player:GetHeight() / 2 ) - ( GuiRoot:GetHeight() / 2 )
	end )
	UnitInfo_Buffs_Target:ClearAnchors()
	UnitInfo_Buffs_Target:SetAnchor( CENTER, GuiRoot, CENTER, self.savedVars.buffsTargetOffsetX, self.savedVars.buffsTargetOffsetY )
	UnitInfo_Buffs_Target:SetHandler( 'OnMoveStop', function()
		self.savedVars.buffsTargetOffsetX = UnitInfo_Buffs_Target:GetLeft() + ( UnitInfo_Buffs_Target:GetWidth() / 2 ) - ( GuiRoot:GetWidth() / 2 )
		self.savedVars.buffsTargetOffsetY = UnitInfo_Buffs_Target:GetTop() + ( UnitInfo_Buffs_Target:GetHeight() / 2 ) - ( GuiRoot:GetHeight() / 2 )
	end )

	-- set parents
	UnitInfo_PlayerUltimate:SetParent( ActionButton8 )

	-- set event handlers
	self.control:RegisterForEvent( EVENT_EFFECT_CHANGED,         function( changeType, effectSlot, effectName, unitTag, beginTime, endTime, stackCount, iconName, buffType, effectType, abilityType, statusEffectType ) self:OnBuffUpdate( unitTag ) end )
	self.control:RegisterForEvent( EVENT_PLAYER_ACTIVATED,       function() self:OnBuffUpdate( 'player' ) end )
	self.control:RegisterForEvent( EVENT_RETICLE_TARGET_CHANGED, function() self:OnBuffUpdate( 'reticleover' ) end )
	self.control:RegisterForEvent( EVENT_GROUP_MEMBER_CONNECTED_STATUS, function( unitTag, isOnline ) self:UpdateGroup( 'EVENT_GROUP_MEMBER_CONNECTED_STATUS' ) end )
	self.control:RegisterForEvent( EVENT_GROUP_MEMBER_JOINED, function( memberName ) self:UpdateGroup( 'EVENT_GROUP_MEMBER_JOINED' ) end )
	self.control:RegisterForEvent( EVENT_GROUP_MEMBER_LEFT, function( memberName, reason, wasLocalPlayer ) self:UpdateGroup( 'EVENT_GROUP_MEMBER_LEFT' ) end )
	self.control:RegisterForEvent( EVENT_GROUP_DISBANDED, function() self:UpdateGroup( 'EVENT_GROUP_DISBANDED' ) end )
	self.control:RegisterForEvent( EVENT_GROUP_MEMBER_ROLES_CHANGED, function( unitTag, dps, healer, tank ) self:UpdateGroup( 'EVENT_GROUP_MEMBER_ROLES_CHANGED' ) end )
	self.control:RegisterForEvent( EVENT_LEADER_UPDATE, function( leaderTag ) self:UpdateGroup( 'EVENT_LEADER_UPDATE' ) end )
	self.control:SetHandler( 'OnUpdate', function() self:OnUpdate() end )

	-- get group
	self:UpdateGroup()
end

function __UnitInfo:OnUpdate()
	-- limit update speed
	if not _LUI:DelayBuffer( 'UnitInfoUpdate', 40 ) then return end

	-- display target info
	self:OnTargetFrame()

	-- display player info
	self:OnPlayerFrame()

	-- toggle frame on/off
	self:OnPlayerFrameToggle()

	-- display group frame
	self:OnGroupFrame()
end

function __UnitInfo:OnPlayerFrameToggle()
	if not self.savedVars.playerFrameToggle then return end
	if ( self.player.toggling ) then return end

	show = ( self.player.inCombat or self.player.percentHealth ~= 100 or self.player.percentMagicka ~= 100 or self.player.percentStamina ~= 100 or self.player.percentMountStamina ~= 100 )

	-- hide player buffs
	if ( self.savedVars.buffsFrame ) then
		UnitInfo_Buffs_Player:SetAlpha( ( show ) and 1 or 0 )
	end

	-- hide player bars
	if ( self.player.frameIsVisible == true and show == false ) then
		self.player.toggling = true
		local animate, timeline = CreateSimpleAnimation( ANIMATION_ALPHA, UnitInfo_Player )
		animate:SetAlphaValues( 1, 0 )
		animate:SetDuration( 500 )
		timeline:SetPlaybackType( ANIMATION_PLAYBACK_ONE_SHOT )
		timeline:PlayFromStart()
		timeline:SetHandler( 'OnStop', function()
			self.player.toggling       = false
			self.player.frameIsVisible = false
		end )
	elseif ( self.player.frameIsVisible == false and show == true ) then
		self.player.toggling = true
		local animate, timeline = CreateSimpleAnimation( ANIMATION_ALPHA, UnitInfo_Player )
		animate:SetAlphaValues( 0, 1 )
		animate:SetDuration( 500 )
		timeline:SetPlaybackType( ANIMATION_PLAYBACK_ONE_SHOT )
		timeline:PlayFromStart()
		timeline:SetHandler( 'OnStop', function()
			self.player.toggling       = false
			self.player.frameIsVisible = true
		end )
	end
end

function __UnitInfo:OnPlayerFrame()
	if not self.savedVars.playerFrame then return end

	-- display ultimate value
	local powerCurrent, powerMax, powerEffectiveMax = GetUnitPower( 'player', POWERTYPE_ULTIMATE ) -- local slotAbilityCost = GetSlotAbilityCost( 8 )
	UnitInfo_PlayerUltimate:SetText( string.format( '%d / %d', powerCurrent, powerMax ) ) -- ( powerCurrent / slotAbilityCost ) * 100 )

	-- get values
	self.player.name     = _LUI:ParseLanguageString( GetUnitName( 'player' ) )
	self.player.reaction = GetUnitReaction( 'player' )
	self.player.mounted  = IsMounted()
	self.player.inCombat = IsUnitInCombat( 'player' )
	self.player.shielded, self.player.shieldedMax = GetUnitAttributeVisualizerEffectInfo( 'player', ATTRIBUTE_VISUAL_POWER_SHIELDING, STAT_MITIGATION, ATTRIBUTE_HEALTH, POWERTYPE_HEALTH )
	self.player.currentIsBuffed     = GetPlayerStat( STAT_PHYSICAL_RESIST, STAT_BONUS_OPTION_APPLY_BONUS, STAT_SOFT_CAP_OPTION_DONT_APPLY_SOFT_CAP )
	local powerCurrent, powerMax, _ = GetUnitPower( 'player', POWERTYPE_MAGICKA )
	self.player.currentMagicka      = powerCurrent
	self.player.maxMagicka          = powerMax
	local powerCurrent, powerMax, _ = GetUnitPower( 'player', POWERTYPE_HEALTH )
	self.player.currentHealth       = powerCurrent
	self.player.maxHealth           = powerMax
	local powerCurrent, powerMax, _ = GetUnitPower( 'player', POWERTYPE_STAMINA )
	self.player.currentStamina      = powerCurrent
	self.player.maxStamina          = powerMax
	local powerCurrent, powerMax, _ = GetUnitPower( 'player', POWERTYPE_MOUNT_STAMINA )
	self.player.currentMountStamina = powerCurrent
	self.player.maxMountStamina     = powerMax

	-- reset saved values
	if ( self.player.lastMagicka == nil or self.player.lastHealth == nil or self.player.lastStamina == nil or self.player.lastMountStamina == nil or self.player.lastIsBuffed == nil ) then
		self.player.lastMagicka      = self.player.currentMagicka
		self.player.lastHealth       = self.player.currentHealth
		self.player.lastStamina      = self.player.currentStamina
		self.player.lastMountStamina = self.player.currentMountStamina
		self.player.lastIsBuffed     = self.player.currentIsBuffed
		self.player.toggling         = false
		self.player.frameIsVisible   = true
	end

	-- loop bars
	local bars = {
		[ 'health' ] = {
			show          = true,
			showShielded  = true,
			showBuffed    = true,
			showLeader    = false,
			target        = UnitInfo_Player,
			name          = 'Health',
			controlname   = 'Health',
			labelTL       = self.player.name,
			labelTR       = false,
			labelBL       = true,
			labelBR       = true,
			labelIL       = false,
			labelIR       = false,
			data          = self.player,
			width         = 200,
			height        = 40,
			offsetX       = 0,
			offsetY       = 0,
			colorA        = _LUI.config.colors.HEALTH,
			colorB        = _LUI.config.colors.DAMAGE,
		},
		[ 'magicka' ] = {
			show          = true,
			showShielded  = false,
			showBuffed    = false,
			showLeader    = false,
			target        = UnitInfo_Player,
			name          = 'Magicka',
			controlname   = 'Magicka',
			labelTL       = false,
			labelTR       = false,
			labelBL       = true,
			labelBR       = true,
			labelIL       = false,
			labelIR       = false,
			data          = self.player,
			width         = 200,
			height        = 20,
			offsetX       = 0,
			offsetY       = 46,
			colorA        = _LUI.config.colors.MAGICKA,
			colorB        = _LUI.config.colors.MAGICKA,
		},
		[ 'stamina' ] = {
			show          = not self.player.mounted,
			showShielded  = false,
			showBuffed    = false,
			showLeader    = false,
			target        = UnitInfo_Player,
			name          = 'Stamina',
			controlname   = 'Stamina',
			labelTL       = false,
			labelTR       = false,
			labelBL       = true,
			labelBR       = true,
			labelIL       = false,
			labelIR       = false,
			data          = self.player,
			width         = 200,
			height        = 20,
			offsetX       = 0,
			offsetY       = 72,
			colorA        = _LUI.config.colors.STAMINA,
			colorB        = _LUI.config.colors.STAMINA,
		},
		[ 'mountstamina' ] = {
			show          = self.player.mounted,
			showShielded  = false,
			showBuffed    = false,
			showLeader    = false,
			target        = UnitInfo_Player,
			name          = 'MountStamina',
			controlname   = 'MountStamina',
			labelTL       = false,
			labelTR       = false,
			labelBL       = true,
			labelBR       = true,
			labelIL       = false,
			labelIR       = false,
			data          = self.player,
			width         = 200,
			height        = 20,
			offsetX       = 0,
			offsetY       = 72,
			colorA        = _LUI.config.colors.STAMINA,
			colorB        = _LUI.config.colors.STAMINA,
		},
	}
	for index, values in pairs( bars ) do
		self:DisplayUnitBar( values )
	end

	-- save current values
	self.player.lastMagicka = self.player.currentMagicka
	self.player.lastHealth  = self.player.currentHealth
	self.player.lastStamina = self.player.currentStamina
	if ( self.player.currentIsBuffed < self.player.lastIsBuffed ) then
		self.player.lastIsBuffed = self.player.currentIsBuffed
	end
end

function __UnitInfo:OnTargetFrame()
	if not self.savedVars.targetFrame then return end

	-- check reticle
	if ( IsReticleHidden() ) then return end

	-- hide default targetFrame
	ZO_TargetUnitFramereticleover:SetHidden( self.savedVars.targetFrame )

	-- get values
	self.target.name     = _LUI:ParseLanguageString( GetUnitName( 'reticleover' ) )
	self.target.reaction = GetUnitReaction( 'reticleover' )
	self.target.level    = GetUnitLevel( 'reticleover' )
	self.target.veteran  = GetUnitVeteranRank( 'reticleover' )
	self.target.caption  = GetUnitCaption( 'reticleover' )
	self.target.caption  = ( self.target.caption ~= nil ) and self.target.caption or ''
	self.target.class    = _LUI:ParseLanguageString( GetUnitClass( 'reticleover' ) )
	self.target.shielded, self.target.shieldedMax = GetUnitAttributeVisualizerEffectInfo( 'reticleover', ATTRIBUTE_VISUAL_POWER_SHIELDING, STAT_MITIGATION, ATTRIBUTE_HEALTH, POWERTYPE_HEALTH )
	local powerCurrent, powerMax, _ = GetUnitPower( 'reticleover', POWERTYPE_HEALTH )
	self.target.currentHealth       = powerCurrent
	self.target.maxHealth           = powerMax
	if ( self.target.name == '' ) then
		UnitInfo_Target:SetHidden( true )
		return
	else
		UnitInfo_Target:SetHidden( false )
	end

	-- reset saved values
	if ( self.target.lastHealth == nil or self.target.name ~= self.target.lastName ) then
		self.target.lastHealth = self.target.currentHealth
	end

	-- get distance details
	local px, py, ph = GetMapPlayerPosition( 'player' )
	local tx, ty, th = GetMapPlayerPosition( 'reticleover' )
	if not tx and ty then return end

	-- get map details
	local mapTilesX, _   = GetMapNumTiles()
	local mapType        = GetMapType()
	local mapModifier    = 0
	local zoneIndex      = GetCurrentMapZoneIndex()
	if ( self.distanceMods[ zoneIndex ] ~= nil and self.distanceMods[ zoneIndex ][ mapType ] ~= nil ) then
		mapModifier = self.distanceMods[ zoneIndex ][ mapType ]
	elseif ( self.distanceMods[ 0 ][ mapType ] ~= nil ) then
		mapModifier = self.distanceMods[ 0 ][ mapType ]
	end

	-- calc distance
	local rawDistance = math.sqrt( math.pow( ( px - tx ), 2 ) + math.pow( ( py - ty ), 2 ) )
	local distance    = math.floor( rawDistance / mapModifier )

	-- display bar
	self:DisplayUnitBar( {
		show          = true,
		showShielded  = true,
		showBuffed    = false,
		showLeader    = false,
		target        = UnitInfo_Target,
		name          = 'Health',
		controlname   = 'Health',
		labelTL       = self.target.name,
		labelTR       = ( distance > -1 and distance < 200 ) and string.format( '%.0f m', distance ) or '',
		labelBL       = true,
		labelBR       = true,
		labelIL       = string.rep( '•', GetUnitDifficulty( 'reticleover' ) ) .. self.target.caption,
		labelIR       = string.format( '%s %s', ( self.target.veteran >= 1 ) and 'VET'..self.target.veteran or self.target.level, self.target.class ),
		data          = self.target,
		width         = 200,
		height        = 40,
		offsetX       = 0,
		offsetY       = 0,
		colorA        = _LUI.config.colors.HEALTH,
		colorB        = _LUI.config.colors.DAMAGE,
	} )

	-- save current values
	self.target.lastName   = self.target.name
	self.target.lastHealth = self.target.currentHealth
end

function __UnitInfo:UpdateGroup( message )
	if not self.savedVars.groupFrame then return end

	-- reset group
	self.group = {}
	local numGroupChildren = UnitInfo_Group:GetNumChildren()
	for groupNum = 1, numGroupChildren do
		-- get group element
		local control = UnitInfo_Group:GetChild( groupNum )
		control:SetHidden( true )
	end

	-- get group size
	local groupSize = GetGroupSize()
	if ( groupSize == nil ) then return end

	-- get group members
	for index = 1, groupSize do
		local unitTag = GetGroupUnitTagByIndex( index )
		self.group[ unitTag ] = {}
		self.group[ unitTag ].name             = _LUI:ParseLanguageString( GetUnitName( unitTag ) )
		self.group[ unitTag ].classID          = GetUnitClassId( unitTag )
		self.group[ unitTag ].isLeader         = IsUnitGroupLeader( unitTag )
		_, self.group[ unitTag ].lastHealth, _ = GetUnitPower( unitTag, POWERTYPE_HEALTH )
		self:UpdateGroupMember( unitTag )
	end
end

function __UnitInfo:OnGroupFrame()
	if not self.savedVars.groupFrame or _LUI:DelayBuffer( 'UnitInfoUpdateGroupFrame', 100 ) then return end

	-- loop group members
	local i          = 0
	local groupSize  = 4
	local isLarge    = ( GetGroupSize() > groupSize )
	local width      = ( isLarge ) and 75 or 150
	local height     = 40
	local padding    = ( isLarge ) and { 10, 10 } or { 10, 20 }
	for unitTag, unitData in pairs( self.group ) do
		-- update group member data
		self:UpdateGroupMember( unitTag )

		-- switch labels on largeGroup
		local labelBL = true
		local labelIR = string.format( '%s %s', ( unitData.veteran >= 1 ) and 'V'..unitData.veteran or unitData.level, self.classABR[ unitData.classID ] )
		if ( isLarge ) then
			labelBL   = labelIR
			labelIR   = false
		end

		-- display bar
		self:DisplayUnitBar( {
			show         = true,
			showShielded = true,
			showBuffed   = false,
			showLeader    = false,
			showLeader   = unitData.isLeader,
			target       = UnitInfo_Group,
			name         = 'Health',
			controlname  = unitTag,
			titleFont    = ( isLarge ) and 'LUIFontUnitTitleSmall' or 'LUIFontUnitTitle',
			labelTL      = unitData.name,
			labelTR      = false,
			labelBL      = labelBL,
			labelBR      = true,
			labelIL      = false,
			labelIR      = labelIR,
			data         = unitData,
			width        = width,
			height       = height,
			offsetX      = ( width  + padding[ 1 ] ) * math.floor( i / groupSize ),
			offsetY      = ( height + padding[ 2 ] ) * ( i % groupSize ),
			colorA       = _LUI.config.colors.HEALTH,
			colorB       = _LUI.config.colors.DAMAGE,
		} )

		-- save current values
		unitData.lastHealth = unitData.currentHealth

		-- iterator
		i = i + 1
	end
end

function __UnitInfo:UpdateGroupMember( unitTag )
	if ( self.group[ unitTag ] == nil ) then return end

	-- get unit status
	self.group[ unitTag ].isOnline = IsUnitOnline( unitTag )
	self.group[ unitTag ].reaction = GetUnitReaction( unitTag )
	self.group[ unitTag ].reaction = GetUnitReaction( unitTag )
	self.group[ unitTag ].level    = GetUnitLevel( unitTag )
	self.group[ unitTag ].veteran  = GetUnitVeteranRank( unitTag )

	-- get unit powers
	self.group[ unitTag ].shielded, self.group[ unitTag ].shieldedMax = GetUnitAttributeVisualizerEffectInfo( unitTag, ATTRIBUTE_VISUAL_POWER_SHIELDING, STAT_MITIGATION, ATTRIBUTE_HEALTH, POWERTYPE_HEALTH )
	local powerCurrent, powerMax, _     = GetUnitPower( unitTag, POWERTYPE_HEALTH )
	self.group[ unitTag ].currentHealth = powerCurrent
	self.group[ unitTag ].maxHealth     = powerMax
end

function __UnitInfo:OnBuffUpdate( unitTag )
	if not self.savedVars.buffsFrame then return end

	-- filter unitTag
	if ( unitTag ~= 'player' and unitTag ~= 'reticleover' ) then return end

	-- get target control
	local targetControl     = ( unitTag == 'player' ) and UnitInfo_Buffs_Player or UnitInfo_Buffs_Target
	local targetControlName = targetControl:GetName()

	-- clear buffs
	if not IsReticleHidden() then
		local numBuffsChildren = targetControl:GetNumChildren()
		for num = 1, numBuffsChildren do
			local buff = targetControl:GetChild( num )
			buff:ClearAnchors()
			buff:SetHidden( true )
			buff.settings.age      = 0
			buff.settings.lifetime = -1
		end
	end

	-- loop buffs
	local numBuffs = GetNumBuffs( unitTag )
	local lastAnchorTarget = targetControl
	for num = 1, numBuffs do
		-- get buff data
		local buffName, timeStarted, timeEnding, buffSlot, stackCount, iconFilename, buffType, effectType, abilityType, statusEffectType = GetUnitBuffInfo( unitTag, num )

		-- get control
		local control = nil
		if ( targetControl:GetNamedChild( '_Buff'..num ) == nil ) then
			control = CreateControlFromVirtual( targetControl:GetName()..'_Buff'..num, targetControl, 'UnitInfo_Buff_Virtual' )
		else
			control = targetControl:GetNamedChild( '_Buff'..num )
		end

		-- control settings
		control.settings          = {}
		control.settings.lifetime = ( timeEnding - timeStarted ) * 1000 - 1
		control.settings.age      = GetGameTimeMilliseconds() + control.settings.lifetime

		-- control setup
		control:SetHidden( false )
		control:ClearAnchors()
		control:SetAnchor( TOPLEFT, lastAnchorTarget, ( lastAnchorTarget ~= targetControl ) and TOPRIGHT or TOPLEFT, 4, 0 ) 
		control:GetNamedChild( '_Bg' ):SetTexture( iconFilename )
		control:GetNamedChild( '_Label' ):SetText( ( control.settings.lifetime < 0 ) and '' or string.format( '%.1f', ( timeEnding - timeStarted ) ) )

		-- build anchor chain
		lastAnchorTarget = control
	end

	-- add update handler
	targetControl:SetHandler( 'OnUpdate', function()
		-- limit update speed
		if not _LUI:DelayBuffer( 'OnBuffsUpdate'..targetControlName, 100 ) then return end

		-- loop buffs
		local isAlive = 0
		local currentTime = GetGameTimeMilliseconds()
		local numBuffsChildren = targetControl:GetNumChildren()
		for buffnum = 1, numBuffsChildren do
			-- get buff
			local buff = targetControl:GetChild( buffnum )

			-- buff label age
			if ( buff.settings.lifetime > 0 ) then
				if ( buff.settings.age ~= 0 and buff.settings.age <= currentTime ) then
					local isValidAnchor, point, relativeTo, relativePoint, offsetX, offsetY = buff:GetAnchor()
					buff:ClearAnchors()
					buff:SetAnchor( point, relativeTo, relativePoint, 0 - buff:GetWidth(), 0 ) 
					buff:SetHidden( true )
					buff.settings.age = 0
				elseif ( buff.settings.age ~= 0 ) then
					local seconds  = ( buff.settings.age - currentTime ) / 1000
					buff:GetNamedChild( '_Label' ):SetText( ( seconds > 60 ) and string.format( '%d m', math.floor( seconds / 60 ) ) or string.format( '%.1f', seconds ) )
				end
			end
		end
	end )
end

function __UnitInfo:DisplayUnitBar( values )
	-- get control
	local control = nil
	if ( values.target:GetNamedChild( '_'..values.controlname..'Bar' ) == nil ) then
		control = CreateControlFromVirtual( values.target:GetName()..'_'..values.controlname..'Bar', values.target, 'UnitInfo_Bar_Virtual' )

		-- add animations
		control:GetNamedChild( '_BgBuffed'):SetHandler( 'OnShow', function()
			local timeline     = ANIMATION_MANAGER:CreateTimeline()
			local animateScale = timeline:InsertAnimation( ANIMATION_SCALE, control:GetNamedChild( '_BgBuffed' ) )
			animateScale:SetScaleValues( 1.25, 1 )
			animateScale:SetDuration( 200 )
			animateScale:SetEasingFunction( ZO_EaseInQuartic )
			local animateAlpha = timeline:InsertAnimation( ANIMATION_ALPHA, control:GetNamedChild( '_BgBuffed' ) )
			animateAlpha:SetAlphaValues( 0, 1 )
			animateAlpha:SetDuration( 200 )
			animateAlpha:SetEasingFunction( ZO_EaseInQuartic )
			timeline:SetPlaybackType( ANIMATION_PLAYBACK_ONE_SHOT )
			timeline:PlayFromStart()
		end )
	else
		control = values.target:GetNamedChild( '_'..values.controlname..'Bar' )
	end

	-- anchor control
	control:SetHidden( not values.show )
	control:SetDimensions( values.width, values.height + 2 )
	control:ClearAnchors()
	control:SetAnchor( TOPLEFT, target, TOPLEFT, values.offsetX, values.offsetY )

	-- set bg
	control:GetNamedChild( '_Bg'):SetEdgeTexture( '', 8, 1, 1 )

	-- set bg buffed
	if ( values.showBuffed and values.data.currentIsBuffed > values.data.lastIsBuffed ) then
		control:GetNamedChild( '_BgBuffed'):SetEdgeTexture( '', 8, 1, 1 )
		control:GetNamedChild( '_BgBuffed'):SetDimensions( control:GetNamedChild( '_Bg'):GetWidth() + 4, control:GetNamedChild( '_Bg'):GetHeight() + 4 )
		control:GetNamedChild( '_BgBuffed'):SetHidden( false )
	else
		control:GetNamedChild( '_BgBuffed'):SetHidden( true )
	end

	-- set leader icon
	control:GetNamedChild( '_IconLeader' ):SetHidden( not values.showLeader )

	-- check bar
	local changed = values.data[ 'last'..values.name ] - values.data[ 'current'..values.name ]

	-- increase current/max values if shielded
	local shielded    = 0
	local shieldedMax = 0
	if ( values.showShielded and values.data.shielded ~= nil ) then
		shielded    = values.data.shielded
		shieldedMax = values.data.shieldedMax
	end
	local current    = values.data[ 'current'..values.name ] + shielded
	local currentMax = values.data[ 'max'..values.name ] + shieldedMax

	-- display bar
	local barA           = control:GetNamedChild( '_BarA' ) -- normal
	local barAPercentage = values.data[ 'current'..values.name ] / currentMax * 100
	local barAWidth      = ( control:GetWidth() - 2 ) / 100 * barAPercentage
	barA:SetDimensions( barAWidth, values.height )
	barA:SetColor( values.colorA.r, values.colorA.g, values.colorA.b )
	local barB           = control:GetNamedChild( '_BarB' ) -- changed since last
	local barBPercentage = ( current + changed ) / currentMax * 100
	local barBWidth      = ( control:GetWidth() - 2 ) / 100 * barBPercentage
	barB:SetHeight( values.height )
	barB:SetColor( values.colorB.r, values.colorB.g, values.colorB.b )
	local barC           = control:GetNamedChild( '_BarC' ) -- shielded
	local barCPercentage = shielded / currentMax * 100
	local barCWidth      = ( control:GetWidth() - 2 ) / 100 * barCPercentage
	if ( shielded > 0 ) then
		barC:SetHidden( false )
		barC:ClearAnchors()
		barC:SetAnchor( TOPLEFT, nil, nil, barAWidth + 1, 1 )
		barC:SetDimensions( barCWidth, values.height )
		barC:SetColor( _LUI.config.colors.SHIELDED.r, _LUI.config.colors.SHIELDED.g, _LUI.config.colors.SHIELDED.b )
		barAPercentage = barAPercentage + barCPercentage
	else
		barC:SetHidden( true )
	end

	-- set percentage to player table
	values.data[ 'percent'..values.name ] = barAPercentage

	-- animate bar
	if ( changed ~= 0 ) then
		local animateSize, animateTimeLine = CreateSimpleAnimation( ANIMATION_SIZE, barB )
		animateSize:SetStartAndEndWidth( barBWidth, barAWidth + barCWidth )
		animateSize:SetStartAndEndHeight( barB:GetHeight(), barB:GetHeight() )
		animateSize:SetDuration( 1000 )
		animateTimeLine:SetPlaybackType( ANIMATION_PLAYBACK_ONE_SHOT )
		animateTimeLine:PlayFromStart()
	end

	-- get labels
	local isOnline = ( values.data.isOnline == nil or values.data.isOnline )
	local labelTL  = ( values.labelTL ~= false ) and values.labelTL or ''
	local labelTR  = ( values.labelTR ~= false ) and values.labelTR or ''
	local labelBL  = ( values.labelBL ~= false ) and values.labelBL or ''
	local labelBR  = ( values.labelBR ~= false ) and values.labelBR or ''
	local labelIL  = ( values.labelIL ~= false ) and values.labelIL or ''
	local labelIR  = ( values.labelIR ~= false ) and values.labelIR or ''

	-- set data labels
	if ( labelBL == true or not isOnline or values.data.reaction == UNIT_REACTION_DEAD ) then
		if ( values.data.reaction == UNIT_REACTION_DEAD ) then
			labelBL = 'dead'
		elseif ( not isOnline ) then
			labelBL = 'offline'
		else
			local shieldstr = ( shielded > 0 ) and string.format( '+ %d / %d', shielded, shieldedMax ) or ''
			labelBL = string.format( '%d / %d %s', values.data[ 'current'..values.name ], values.data[ 'max'..values.name ], shieldstr )
		end
	end
	if ( labelBR == true ) then
		labelBR = string.format( '%d%%', barAPercentage )
	end

	-- set fonts
	if ( values.titleFont ~= nil ) then
		control:GetNamedChild( '_LabelTL' ):SetFont( values.titleFont )
		control:GetNamedChild( '_LabelTR' ):SetFont( values.titleFont )
	else
		control:GetNamedChild( '_LabelTL' ):SetFont( ( string.len( labelTL ) > 15 ) and 'LUIFontUnitTitleSmall' or 'LUIFontUnitTitle' )
	end

	-- set color
	local color = _LUI.config.colors.WHITE
	if ( values.data.reaction == UNIT_REACTION_FRIENDLY ) then
		color = _LUI.config.colors.GREEN
	elseif ( values.data.reaction == UNIT_REACTION_HOSTILE ) then
		color = _LUI.config.colors.RED
	elseif ( values.data.reaction == UNIT_REACTION_INTERACT ) then
		color = _LUI.config.colors.YELLOW
	end
	control:GetNamedChild( '_LabelTL' ):SetColor( color.r, color.g, color.b )
	control:GetNamedChild( '_LabelTR' ):SetColor( color.r, color.g, color.b )

	-- set color and text
	control:GetNamedChild( '_LabelTL' ):SetText( labelTL )
	control:GetNamedChild( '_LabelTR' ):SetText( labelTR )
	control:GetNamedChild( '_LabelBL' ):SetText( labelBL )
	control:GetNamedChild( '_LabelBR' ):SetText( labelBR )
	control:GetNamedChild( '_LabelIL' ):SetText( labelIL )
	control:GetNamedChild( '_LabelIR' ):SetText( labelIR )

	-- set visibility
	control:GetNamedChild( '_LabelBR' ):SetHidden( not isOnline )
	control:GetNamedChild( '_LabelIL' ):SetHidden( not isOnline )
	control:GetNamedChild( '_LabelIR' ):SetHidden( not isOnline )
end

function __UnitInfo:DistanceDebug()
	local mapIndex  = GetCurrentMapIndex()
	local zoneIndex = GetCurrentMapZoneIndex()
	mapIndex  = ( mapIndex ~= nil ) and mapIndex or -1
	zoneIndex = ( zoneIndex ~= nil ) and zoneIndex or -1
	CONSOLE:LogInfo( string.format( '[DistanceDebug] MapName: %s, MapIndex: %d, ZoneIndex: %d', GetMapName(), mapIndex, zoneIndex ) )
end

function __UnitInfo:GetSettings( LAM, LAMPanelID, addOnName )
	LAM:AddCheckbox( LAMPanelID, string.format( '%s_SettingsUnitInfoGroupFrameCheckbox', addOnName ), 'Show Group Frame (beta)', '',
		function() return self.savedVars.groupFrame end,
		function()
			self.savedVars.groupFrame = not self.savedVars.groupFrame
			UnitInfo_Group:SetHidden( not self.savedVars.groupFrame )
			ZO_UnitFramesGroups:SetHidden( self.savedVars.groupFrame )
			self:UpdateGroup()
		end,
	false, '' )
	LAM:AddCheckbox( LAMPanelID, string.format( '%s_SettingsUnitInfoTargetFrameCheckbox', addOnName ), 'Show Target Frame', '',
		function() return self.savedVars.targetFrame end,
		function()
			self.savedVars.targetFrame = not self.savedVars.targetFrame
			UnitInfo_Target:SetHidden( not self.savedVars.targetFrame )
			ZO_TargetUnitFramereticleover:SetHidden( self.savedVars.targetFrame )
		end,
	false, '' )
	LAM:AddCheckbox( LAMPanelID, string.format( '%s_SettingsUnitInfoPlayerFrameCheckbox', addOnName ), 'Show Player Frame', '',
		function() return self.savedVars.playerFrame end,
		function()
			self.savedVars.playerFrame = not self.savedVars.playerFrame
			UnitInfo_Player:SetHidden( not self.savedVars.playerFrame )
			ZO_PlayerAttributeMagicka:SetHidden( self.savedVars.playerFrame )
			ZO_PlayerAttributeHealth:SetHidden( self.savedVars.playerFrame )
			ZO_PlayerAttributeStamina:SetHidden( self.savedVars.playerFrame )
			ZO_PlayerAttributeMountStamina:SetHidden( self.savedVars.playerFrame )
		end,
	false, '' )
	LAM:AddCheckbox( LAMPanelID, string.format( '%s_SettingsUnitInfoBuffsFrameCheckbox', addOnName ), 'Show Buffs Frame', '',
		function() return self.savedVars.buffsFrame end,
		function()
			self.savedVars.buffsFrame = not self.savedVars.buffsFrame
			UnitInfo_Buffs:SetHidden( not self.savedVars.buffsFrame )
		end,
	false, '' )
	LAM:AddCheckbox( LAMPanelID, string.format( '%s_SettingsUnitInfoPlayerFrameToggleCheckbox', addOnName ), 'Toggle Player Frame and Buffs', '',
		function() return self.savedVars.playerFrameToggle end,
		function()
			self.savedVars.playerFrameToggle = not self.savedVars.playerFrameToggle
			UnitInfo_Player:SetAlpha( ( not self.savedVars.playerFrameToggle ) and 1 or UnitInfo_Player:GetAlpha() )
			UnitInfo_Buffs_Player:SetAlpha( ( not self.savedVars.playerFrameToggle ) and 1 or UnitInfo_Buffs_Player:GetAlpha() )
		end,
	false, '' )
end